//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SettingsUnit.h"
#include "Plugin.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmSettings *frmSettings;
//---------------------------------------------------------------------------
__fastcall TfrmSettings::TfrmSettings(TComponent* Owner)
	: TForm(Owner)
{
	this->appSettings = NULL;
	pages->ActivePage = tsCommon;
}
//---------------------------------------------------------------------------
void __fastcall TfrmSettings::FormShow(TObject *Sender)
{
    assert(appSettings);
	tmpSettings = *appSettings;
	chbDetectIpAtConnect->Checked = tmpSettings.bDetectIpAtConnect;
	cmbAfterSend->ItemIndex = tmpSettings.iAfterSend;
	chbSendAsPing->Checked = tmpSettings.bSendAsPing;
	edPing->Text = tmpSettings.asPingCommand;
	chbBeepOnDisconnect->Checked = tmpSettings.bBeepOnDisconnect;
	chbAutoReconnect->Checked = tmpSettings.bAutoReconnect;
	chbLogConnectionState->Checked = tmpSettings.bLogConnectionState;
	chbAutoComplete->Checked = tmpSettings.bAutoComplete;
	chbAutoCompleteCaseSensitive->Checked = tmpSettings.bAutoCompleteCaseSensitive;
	cmbTransmittedText->ItemIndex = tmpSettings.iSendSuffix;
	chbClearAtReconnect->Checked = tmpSettings.bClearWindowAtReconnect;
	chbAlwaysOnTop->Checked = tmpSettings.bAlwaysOnTop;
	chbTcpKeepAlive->Checked = tmpSettings.bKeepAlive;
	cmbMaxUiLogLines->ItemIndex = -1;
	for (int i=0; i<cmbMaxUiLogLines->Items->Count; i++)
	{
		if ((unsigned int)StrToInt(cmbMaxUiLogLines->Items->Strings[i]) >= tmpSettings.iMaxUiLogLines)
		{
			cmbMaxUiLogLines->ItemIndex = i;
			break;
		}
	}
	if (cmbMaxUiLogLines->ItemIndex == -1)
	{
		cmbMaxUiLogLines->ItemHeight = cmbMaxUiLogLines->Items->Count - 1;
	}
	lvPlugins->Items->Count = Plugin::instances.size();
	lvPlugins->Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TfrmSettings::btnCancelClick(TObject *Sender)
{
	this->Close();	
}
//---------------------------------------------------------------------------
void __fastcall TfrmSettings::btnApplyClick(TObject *Sender)
{
	tmpSettings.bLogConnectionState = chbLogConnectionState->Checked;
	tmpSettings.asPingCommand = edPing->Text;
	tmpSettings.bBeepOnDisconnect = chbBeepOnDisconnect->Checked;	
	*appSettings = tmpSettings;
	this->Close();	
}
//---------------------------------------------------------------------------
void __fastcall TfrmSettings::chbDetectIpAtConnectClick(TObject *Sender)
{
	tmpSettings.bDetectIpAtConnect = chbDetectIpAtConnect->Checked;	
}
//---------------------------------------------------------------------------

void __fastcall TfrmSettings::chbAutoCompleteClick(TObject *Sender)
{
	tmpSettings.bAutoComplete = chbAutoComplete->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TfrmSettings::cmbAfterSendChange(TObject *Sender)
{
	tmpSettings.iAfterSend = cmbAfterSend->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TfrmSettings::cmbTransmittedTextChange(TObject *Sender)
{
	tmpSettings.iSendSuffix = cmbTransmittedText->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TfrmSettings::chbClearAtReconnectClick(TObject *Sender)
{
	tmpSettings.bClearWindowAtReconnect = chbClearAtReconnect->Checked;	
}
//---------------------------------------------------------------------------

void __fastcall TfrmSettings::chbAlwaysOnTopClick(TObject *Sender)
{
	tmpSettings.bAlwaysOnTop = chbAlwaysOnTop->Checked;	
}
//---------------------------------------------------------------------------

void __fastcall TfrmSettings::chbAutoReconnectClick(TObject *Sender)
{
	tmpSettings.bAutoReconnect = chbAutoReconnect->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TfrmSettings::chbAutoCompleteCaseSensitiveClick(TObject *Sender)
{
	tmpSettings.bAutoCompleteCaseSensitive =
		chbAutoCompleteCaseSensitive->Checked;	
}
//---------------------------------------------------------------------------

void __fastcall TfrmSettings::chbTcpKeepAliveClick(TObject *Sender)
{
	tmpSettings.bKeepAlive = chbTcpKeepAlive->Checked;	
}
//---------------------------------------------------------------------------

void __fastcall TfrmSettings::chbSendAsPingClick(TObject *Sender)
{
	tmpSettings.bSendAsPing = chbSendAsPing->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TfrmSettings::cmbMaxUiLogLinesChange(TObject *Sender)
{
	tmpSettings.iMaxUiLogLines = StrToInt(cmbMaxUiLogLines->Text);	
}
//---------------------------------------------------------------------------

void __fastcall TfrmSettings::lvPluginsData(TObject *Sender, TListItem *Item)
{
	int id = Item->Index;
	std::set<class Plugin*>::iterator iter = Plugin::instances.begin();
	for (int i=0; i<id; i++)
		++iter;
	Item->Caption = (*iter)->GetFilename();
}
//---------------------------------------------------------------------------

void __fastcall TfrmSettings::lvPluginsDblClick(TObject *Sender)
{
	TListItem *Item = lvPlugins->Selected;
	if (Item == NULL)
		return;
	int id = Item->Index;
	std::set<class Plugin*>::iterator iter = Plugin::instances.begin();
	for (int i=0; i<id; i++)
		++iter;
	(*iter)->ShowSettings();
}
//---------------------------------------------------------------------------



