//---------------------------------------------------------------------------

#ifndef TcpScannerUnitH
#define TcpScannerUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Sockets.hpp>

/*
Starting from Windows XP SP2 (and on through Vista), Microsoft has crippled down
consumer versions of Windows, officially in order to limit the possibilities of
insecure Windows machines to act as hosts for Internet attacks executed by worms
and trojans. Unfortunately, these changes also made non-server editions of Windows
a lot less capable for doing network administrations tasks, such as scanning.

Windows implementation of TCP connection attempt rate limiting limits the number
of simultaneous connection attempts to 10 on XP SP2 or 2 to 25, depending on the
edition of Vista. The previous limit was over 65,000. You can check if you reach
this limit by examining the Event Log after scanning: look for the Event ID 4226,
which corresponds to this problem.

For scanning purposes, that means you can have at most this number of scanning
threads if you want to get reliable results. The number of scanning threads
affects the maximum number of hosts scanned simultaneously and therefore the
maximum number of connections made at each moment.
*/

// should be lower than allowed by XP SP2 limit of ten opening connections
// (10 in Pro, 5 in home?) 
#define MAX_THREADS 1

class TIPAddress;

//---------------------------------------------------------------------------
class TfrmTcpScanner : public TForm
{
__published:	// IDE-managed Components
	TPanel *Panel1;
	TLabel *Label1;
	TLabel *Label2;
	TEdit *edPort;
	TButton *btnStart;
	TGroupBox *GroupBox1;
	TTimer *tmrNewConnect;
	TListView *lvFound;
	TStatusBar *StatusBar1;
	TLabel *Label3;
	TLabel *Label4;
	TEdit *edConnectionTimeout;
	void __fastcall btnStartClick(TObject *Sender);
	void __fastcall tmrNewConnectTimer(TObject *Sender);
private:	// User declarations
	int iCurrentIP;
	unsigned int adrStop;
	int iConnectionTimeoutUs;
	TIPAddress *edIpStart;
	TIPAddress *edIpStop;
public:		// User declarations
	__fastcall TfrmTcpScanner(TComponent* Owner);
	__fastcall ~TfrmTcpScanner();
	void __fastcall ConnectThreadTerminated();
	int iActiveThreads;
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmTcpScanner *frmTcpScanner;
//---------------------------------------------------------------------------
#endif
