//---------------------------------------------------------------------------

#ifndef mainUnitH
#define mainUnitH
//---------------------------------------------------------------------------
#include <stdio.h>
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <Sockets.hpp>
#include <ScktComp.hpp>
#include <Buttons.hpp>
#include <ToolWin.hpp>
#include <Dialogs.hpp>
#include <ImgList.hpp>

//#include <deque>
#include <vector>
//---------------------------------------------------------------------------
class TrayIcon;


class TfrmMain : public TForm
{
__published:	// IDE-managed Components
	TMainMenu *MainMenu;
	TMenuItem *miFile;
	TMenuItem *miHelp;
	TPanel *pnlBottom;
	TMenuItem *miExit;
	TMenuItem *Settings1;
	TPanel *pnlBottomRight;
	TButton *btnSend;
	TRichEdit *redMain;
	TEdit *edSend;
	TStatusBar *StatusBar;
	TMenuItem *miConnection;
	TMenuItem *miDisconnect;
	TMenuItem *miConnectTo;
	TMenuItem *miLastConnections;
	TClientSocket *ClientSocket;
	TMenuItem *miAbout;
	TMenuItem *miAppSettings;
	TSpeedButton *btnSendOnEnter;
	TToolBar *ToolBar;
	TMenuItem *miLogToFile;
	TSaveDialog *SaveDialog;
	TToolButton *ToolButton1;
	TToolButton *btnRecord;
	TImageList *imglToolbar;
	TToolButton *btnAutoScroll;
	TToolButton *ToolButton2;
	TToolButton *btnClear;
	TMenuItem *miTools;
	TMenuItem *miTcpScanner;
	TMenuItem *miTrayHide;
	TToolButton *ToolButton3;
	TToolButton *btnReconnect;
	TToolButton *btnDisconnect;
	TTimer *tmrLogRefresh;
	TListBox *lboxAutoComplete;
	TPopupMenu *popupRichEdit;
	TMenuItem *miCopy;
	TMenuItem *miIcmpPing;
	TMenuItem *miView;
	TMenuItem *miViewLog;
	TTimer *tmrTextPing;
	void __fastcall miExitClick(TObject *Sender);
	void __fastcall miConnectToClick(TObject *Sender);
	void __fastcall ClientSocketConnect(TObject *Sender, TCustomWinSocket *Socket);
	void __fastcall ClientSocketError(TObject *Sender, TCustomWinSocket *Socket,
          TErrorEvent ErrorEvent, int &ErrorCode);
	void __fastcall ClientSocketRead(TObject *Sender, TCustomWinSocket *Socket);
	void __fastcall ClientSocketDisconnect(TObject *Sender,
          TCustomWinSocket *Socket);
	void __fastcall miDisconnectClick(TObject *Sender);
	void __fastcall btnSendClick(TObject *Sender);
	void __fastcall MRUClick(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall miAboutClick(TObject *Sender);
	void __fastcall edSendKeyUp(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall edSendKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall miAppSettingsClick(TObject *Sender);
	void __fastcall btnSendOnEnterClick(TObject *Sender);
	void __fastcall btnAutoScrollClick(TObject *Sender);
	void __fastcall miLogToFileClick(TObject *Sender);
	void __fastcall btnClearClick(TObject *Sender);
	void __fastcall miTcpScannerClick(TObject *Sender);
	void __fastcall miTrayHideClick(TObject *Sender);
	void __fastcall btnDisconnectClick(TObject *Sender);
	void __fastcall btnReconnectClick(TObject *Sender);
	void __fastcall tmrLogRefreshTimer(TObject *Sender);
	void __fastcall lboxAutoCompleteKeyPress(TObject *Sender, char &Key);
	void __fastcall lboxAutoCompleteKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
	void __fastcall miCopyClick(TObject *Sender);
	void __fastcall miIcmpPingClick(TObject *Sender);
	void __fastcall miViewLogClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall tmrTextPingTimer(TObject *Sender);
private:	// User declarations
	TrayIcon *trIcon;
	const int MRUConnections;
	AnsiString asLastHost;
	int iLastPort;
	bool bDisconnectExpected;
	bool bRefreshLog;
	AnsiString asLastHistoryEntry;
	TStringList *slistAutoComplete;
	TStringList *slistHistory;
	int iHistoryMaxSize;
	int iCurrentHistoryPos;
	FILE *pLogFile;
	void ConnectTo(AnsiString asHost, int iPort);
	void Reconnect(void);
	void SetStatus(char *lpData, ...);
	void LogConnectionState(char *lpData, ...);
	void AddTextToLog(bool bUseTimestamp, TColor color, AnsiString asText);
	void AddBufToLog(bool bUseTimestamp, TColor color, char *Buf, int iLength);
	void Send(void);
	void Send(AnsiString text);
	void ShowAutoCompleteList(AnsiString theText);
	void LoadPlugin(AnsiString filename);

	struct LogEntry
	{
		TColor color;
		AnsiString asText;
	};
//	std::deque<LogEntry> queDisplay;
	std::vector<LogEntry> queDisplay;
public:		// User declarations
	__fastcall TfrmMain(TComponent* Owner);
	__fastcall ~TfrmMain();	
	void __fastcall OnTrayIconLeftBtnDown(TObject *Sender);
	void OnPluginSend(void*, int);
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmMain *frmMain;
//---------------------------------------------------------------------------
#endif
